package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.TestUnti.VerificationMethod;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 75.用户提交模考和真题试卷和客观题估分做题记录接口优化
 * 
 * @author puhui
 *
 */
public class submitPaperRecord extends TK implements API {
	public String parameter;//参数集合
	
	public String user_id;//用户id
	public String item_id;//考试项目id
	public String orgin_id;//试卷id
	public String record_id;//做题记录id
	public String data_ex;//data_ex

	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
//		user_id = MapUtil.getParameter(parameter, "data").trim();
//		item_id = MapUtil.getParameter(parameter, "item_id").trim();
//		question_id = MapUtil.getParameter(parameter, "question_id").trim();
		
		data_ex="[{\"channel\": 1,\"user_id\": code,\"is_final\": 1,\"item_id\": 88,\"orgin\": 1,\"orgin_id\": 629,\"upload_time\": 1535606252,\"record_id\": code,\"appid\":\"tiku\",\"questions\": [{\"question_number\": 1,\"question_id\": 29964,\"duration\": 3,\"is_signed\": 1,\"type\": 1,\"user_answer\": 237276}]}]";
		
		if (parameter.contains("orgin")) {
			data_ex = data_ex.replace("\"orgin\": 1", "\"orgin\":"+ 3 );
		}
		
		if (data_ex.contains("\"user_id\": code")) {
			user_id=ListUtil.getListValue(user_idList,0);
			parameter = data_ex.replace("\"user_id\": code", "\"user_id\":\""+ user_id + "\"");
		}
		if (data_ex.contains("\"record_id\": code")) {
			parameter = parameter.replace("\"record_id\": code", "\"record_id\":\""+ record_id_L + "\"");
		}
		data.put("parameter", "\"data\":"+parameter+",\"appid\":\"tiku\"");
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		String parameter1 = MapUtil.getValue("parameter", data);
		Map<String,String> m=new HashMap<String,String>();
		m.put("data", parameter);
		m.put("appid", "tiku");
		m.put("sign", GetSignValue(parameter1));
		
		Response re = RequestDataUtils.post_form_data(data,tk_token, Url,m);
//		Response re = RequestDataUtils.Post_token(data, Url, tk_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("接口响应成功！".equals(msg)){
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
